stage = 0

function onDeployStart()
	
	LevelStageControl(0)
	SetTriggerCallbacks("TriggerCharge", onTriggerEnter_TriggerCharge, onTriggerLeave_TriggerCharge)
end

function onLevelStart()
	SetDisplayTimer(0,0)
	LevelStageControl(1)
	SetWinnable(false)
end

function onTriggerEnter_TriggerCharge(unit)
	if unit.attacker and stage <= 1 then
		LevelStageControl(2)
		DisableTrigger("StartTrigger")
	end
end

function onDefenderDestroyed()
	if stage <= 3 then
		LevelStageControl(4)
	elseif stage >= 7 then
		LevelStageControl()
	end
end

function onAttackerDestroyed()
	Lose()
end

function LevelStageControl(newStage)

	print("LevelLogic: LevelStageControl(", newStage, ")")

	if not newStage then
		newStage = stage
		print("LevelLogic: No stage given so set to ", stage)

	elseif newStage > stage then
		print("LevelLogic: Stage updated from ", stage , " to ", newStage)
		stage = newStage
	end
	
	-- do nothing if this is a call for an old stage
	if newStage < stage then
		print("LevelLogic: Reduntant call for stage ", newStage)
		
	-- set up
	elseif stage == 0 then
		SpawnUnits("Defenders")
	
	-- start game
	elseif stage == 1 then
		SpawnUnits("Defenders")
		local units = GetUnits("Defenders", "*", 1)
		for i,unit in pairs(units) do
			print("STAND GROUND:", unit)
			SetUnitStandGround(unit, true)
		end
	
	-- defenders attack player
	elseif stage == 2 then
		ShowDialog("Portraits/PaladdinHero", "The opposition are attacking sire, brace yourself!")	
		local  units = GetUnits("Defenders","*Militia*",1)
		for i, unit in pairs(units) do
			print("ATTACK!!!:", unit)
			SetUnitStandGround(unit, false)
		end
		stage = 3
		
	-- holding stage, do nothing
	elseif stage == 3 then
	
	-- defenders have been defeated
	elseif stage == 4 then
		ShowDialog("Portraits/PaladdinHero", "Now the enemy will try and retake it - organise your troops")	
		SwitchBarricadesToAttacker()
		AddTimer(5,LevelStageControl,5)
	
	-- send in AI attackers for the player to defend against
	elseif stage == 5 then
		ShowDialog("Portraits/PaladdinHero", "Here they come, hold out for 2 minutes!")
		SetDisplayTimer(120,0)
		AddTimer(120, LevelStageControl, 7)
		SpawnUnits("Reinforcement")
		AddTimer(10,LevelStageControl, 6)
		
	-- refresh the AI attackers if we've not got enough
	elseif stage == 6 then
		local units = GetUnits("Reinforcement")
		print("Units at ", #units)
		if #units <= 2 then
			RespawnUnits("Reinforcement")
		end
		AddTimer(10,LevelStageControl, 6)
		
	-- the player has held out long enough
	elseif stage == 7 then
		local units = GetUnits("Reinforcement")
		if #units > 0 then
			ShowDialog("Portraits/PaladdinHero", "We've almost done it, just clear up the last few units.")
		else
			ShowDialog("Portraits/PaladdinHero", "That's it, we've done it! Huzzah!!!!!")
			AddTimer(1,LevelStageControl, 8)
		end
	
	-- end of the level
	elseif stage == 8 then
		Win()
	end
end
