destroyed = 0
convo_done = false
in_zone = 0

function onDeployStart()

	createStartingTroops(False)
	SetTriggerCallbacks("allyspawn", allyspawn_onTriggerEnter, allyspawn_onTriggerLeave)
	SetTriggerCallbacks("flip", flip_onTriggerEnter, flip_onTriggerLeave)
	ShowDialog("Portraits/Guard_talkinghead", "TXT_CAMP_UNAK3_2_INTRO")
	SetWinnable(false)
	
	
end

function onLevelStart()
	
	SetAI1() -- allies
	SetAI2() -- enemy attacking allies3
	SetVictoryBarEnabled(false)
	
end

-- AI Fight START

function SetAI1() -- sets allies to not do damage
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
			--SetUnitStandGround(unit,true)
			DisableAttackDamage(unit)
	end
end

function SetAI2() -- sets attacker on allies to not do damage
	local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
			SetUnitStandGround(unit,true)
			DisableAttackDamage(unit)
	end
end

function flip_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("flip") 
		local units = GetUnits("*", "*", 2) --switches sides and puts damage on
		for i,unit in pairs(units) do
			EnableAttackDamage(unit)
		end
		local units = GetUnits("*", "*", 3)
		for i,unit in pairs(units) do
			SwitchSide(unit, 1)
			EnableAttackDamage(unit)
		end
		ShowDialog("Portraits/dip_ragnar_talkinghead", "TXT_CAMP_UNAK3_2_HELP")
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		
		destroyed = destroyed + 1
		if destroyed == 2  then
			ShowDialog("Portraits/dip_ragnar_talkinghead", "TXT_CAMP_UNAK3_2_ALLY")
			AddTargetCircle("objective")
			RagnarWalkies()
		end
	end
end


-- AI Fight END

--START Story Section

function RagnarWalkies()

	GiveNamedUnitMoveOrder("ragnarpal", "objective")
	
end

function allyspawn_onTriggerEnter(unit)

	if unit.attacker then
		in_zone = in_zone + 1
		if in_zone >= 2 then
			ClearTargetCircles("objective")
			SpawnUnits("allyspawn")
			DisableTrigger("allyspawn")
			ShowDialog("Portraits/dip_ragnar_talkinghead", "TXT_CAMP_UNAK3_2_THANK")
			AddTimer(8.0, finalspawn)
		end
	end

end

function finalspawn()

	SpawnUnits("finalspawn")
	SetWinnable(true)
	ShowDialog("Portraits/dip_ragnar_talkinghead", "TXT_CAMP_UNAK3_2_ENEMY")

end

-- End Story Section

function createStartingTroops(forPlinthInspector)
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 6 then
			SpellLevel = Rank -2
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
		end
	
	SpawnUnits("start")
	SpawnUnits("ragnarpal")

	if forPlinthInspector then
		SpawnUnits("start")
		SpawnUnits("finalspawn")
	end
end